OpenCV: cv::Scalar_< _Tp > Class Template Reference

| OpenCV 3.4.2 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | List of all members
cv::Scalar_< _Tp > Class Template Reference
Core functionality » Basic structures

Template class for a 4-element vector derived from Vec. More...

`#include "types.hpp"`

Inheritance diagram for cv::Scalar_< _Tp >:

## Public Member Functions
| Scalar_ ()
| default constructor More...
| Scalar_ (_Tp v0, _Tp v1, _Tp v2=0, _Tp v3=0)
| Scalar_ (_Tp v0)
template<typename _Tp2 , int cn>
| Scalar_ (const Vec< _Tp2, cn > &v)
Scalar_< _Tp > | conj () const
| returns (v0, -v1, -v2, -v3) More...
bool | isReal () const
| returns true iff v1 == v2 == v3 == 0 More...
Scalar_< _Tp > | mul (const Scalar_< _Tp > &a, double scale=1) const
| per-element product More...
template<typename T2 >
| operator Scalar_< T2 > () const
| conversion to another data type More...
Public Member Functions inherited from cv::Vec< _Tp, 4 >
| Vec ()
| default constructor More...
| Vec (_Tp v0)
| 1-element vector constructor More...
| Vec (_Tp v0, _Tp v1)
| 2-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2)
| 3-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2, _Tp v3)
| 4-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4)
| 5-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5)
| 6-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6)
| 7-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7)
| 8-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7, _Tp v8)
| 9-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7, _Tp v8, _Tp v9)
| 10-element vector constructor More...
| Vec (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7, _Tp v8, _Tp v9, _Tp v10, _Tp v11, _Tp v12, _Tp v13)
| 14-element vector constructor More...
| Vec (const _Tp *values)
| Vec (const Vec< _Tp, cn > &v)
| Vec (const Matx< _Tp, cn, 1 > &a, const Matx< _Tp, cn, 1 > &b, Matx_AddOp)
| Vec (const Matx< _Tp, cn, 1 > &a, const Matx< _Tp, cn, 1 > &b, Matx_SubOp)
| Vec (const Matx< _Tp, cn, 1 > &a, _T2 alpha, Matx_ScaleOp)
Vec | conj () const
| conjugation (makes sense for complex numbers and quaternions) More...
Vec | cross (const Vec &v) const
Vec | mul (const Vec< _Tp, cn > &v) const
| per-element multiplication More...
| operator Vec< T2, cn > () const
| conversion to another data type More...
const _Tp & | operator() (int i) const
_Tp & | operator() (int i)
const _Tp & | operator[] (int i) const
_Tp & | operator[] (int i)
Public Member Functions inherited from cv::Matx< _Tp, cn, 1 >
| Matx ()
| default constructor More...
| Matx (_Tp v0)
| 1x1 matrix More...
| Matx (_Tp v0, _Tp v1)
| 1x2 or 2x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2)
| 1x3 or 3x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3)
| 1x4, 2x2 or 4x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4)
| 1x5 or 5x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5)
| 1x6, 2x3, 3x2 or 6x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6)
| 1x7 or 7x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7)
| 1x8, 2x4, 4x2 or 8x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7, _Tp v8)
| 1x9, 3x3 or 9x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7, _Tp v8, _Tp v9)
| 1x10, 2x5 or 5x2 or 10x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7, _Tp v8, _Tp v9, _Tp v10, _Tp v11)
| 1x12, 2x6, 3x4, 4x3, 6x2 or 12x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7, _Tp v8, _Tp v9, _Tp v10, _Tp v11, _Tp v12, _Tp v13)
| 1x14, 2x7, 7x2 or 14x1 matrix More...
| Matx (_Tp v0, _Tp v1, _Tp v2, _Tp v3, _Tp v4, _Tp v5, _Tp v6, _Tp v7, _Tp v8, _Tp v9, _Tp v10, _Tp v11, _Tp v12, _Tp v13, _Tp v14, _Tp v15)
| 1x16, 4x4 or 16x1 matrix More...
| Matx (const _Tp *vals)
| initialize from a plain array More...
| Matx (const Matx< _Tp, m, n > &a, const Matx< _Tp, m, n > &b, Matx_AddOp)
| Matx (const Matx< _Tp, m, n > &a, const Matx< _Tp, m, n > &b, Matx_SubOp)
| Matx (const Matx< _Tp, m, n > &a, _T2 alpha, Matx_ScaleOp)
| Matx (const Matx< _Tp, m, n > &a, const Matx< _Tp, m, n > &b, Matx_MulOp)
| Matx (const Matx< _Tp, m, n > &a, const Matx< _Tp, m, n > &b, Matx_DivOp)
| Matx (const Matx< _Tp, m, l > &a, const Matx< _Tp, l, n > &b, Matx_MatMulOp)
| Matx (const Matx< _Tp, n, m > &a, Matx_TOp)
Matx< _Tp, m, 1 > | col (int i) const
| extract the matrix column More...
double | ddot (const Matx< _Tp, m, n > &v) const
| dot product computed in double-precision arithmetics More...
diag_type | diag () const
| extract the matrix diagonal More...
Matx< _Tp, m, n > | div (const Matx< _Tp, m, n > &a) const
| divide two matrices element-wise More...
_Tp | dot (const Matx< _Tp, m, n > &v) const
| dot product computed with the default precision More...
Matx< _Tp, m1, n1 > | get_minor (int i, int j) const
| extract part of the matrix More...
Matx< _Tp, n, m > | inv (int method=DECOMP_LU, bool *p_is_ok=NULL) const
| invert the matrix More...
Matx< _Tp, m, n > | mul (const Matx< _Tp, m, n > &a) const
| multiply two matrices element-wise More...
| operator Matx< T2, m, n > () const
| conversion to another data type More...
const _Tp & | operator() (int i, int j) const
| element access More...
_Tp & | operator() (int i, int j)
const _Tp & | operator() (int i) const
| 1D element access More...
_Tp & | operator() (int i)
Matx< _Tp, m1, n1 > | reshape () const
| change the matrix shape More...
Matx< _Tp, 1, n > | row (int i) const
| extract the matrix row More...
Matx< _Tp, n, l > | solve (const Matx< _Tp, m, l > &rhs, int flags=DECOMP_LU) const
| solve linear system More...
Vec< _Tp, n > | solve (const Vec< _Tp, m > &rhs, int method) const
Matx< _Tp, n, m > | t () const
| transpose the matrix More...

## Static Public Member Functions
static Scalar_< _Tp > | all (_Tp v0)
| returns a scalar with all elements set to v0 More...
Static Public Member Functions inherited from cv::Vec< _Tp, 4 >
static Vec | all (_Tp alpha)
Static Public Member Functions inherited from cv::Matx< _Tp, cn, 1 >
static Matx | all (_Tp alpha)
static Matx | diag (const diag_type &d)
static Matx | eye ()
static Matx | ones ()
static Matx | randn (_Tp a, _Tp b)
static Matx | randu (_Tp a, _Tp b)
static Matx | zeros ()

## Additional Inherited Members
Public Types inherited from cv::Vec< _Tp, 4 >
enum |
typedef _Tp | value_type
Public Types inherited from cv::Matx< _Tp, cn, 1 >
enum |
typedef Matx< _Tp, shortdim, 1 > | diag_type
typedef Matx< _Tp, m, n > | mat_type
typedef _Tp | value_type
Public Attributes inherited from cv::Matx< _Tp, cn, 1 >
_Tp | val [m *n]
Related Functions inherited from cv::Vec< _Tp, 4 >
static Vec< _Tp1, cn > & | operator+= (Vec< _Tp1, cn > &a, const Vec< _Tp2, cn > &b)
static Vec< _Tp1, cn > & | operator-= (Vec< _Tp1, cn > &a, const Vec< _Tp2, cn > &b)
static Vec< _Tp, cn > | operator+ (const Vec< _Tp, cn > &a, const Vec< _Tp, cn > &b)
static Vec< _Tp, cn > | operator- (const Vec< _Tp, cn > &a, const Vec< _Tp, cn > &b)
static Vec< _Tp, cn > | operator- (const Vec< _Tp, cn > &a)
static Vec< _Tp, cn > & | operator*= (Vec< _Tp, cn > &a, int alpha)
static Vec< _Tp, cn > & | operator*= (Vec< _Tp, cn > &a, float alpha)
static Vec< _Tp, cn > & | operator*= (Vec< _Tp, cn > &a, double alpha)
Vec< _Tp, 4 > & | operator*= (Vec< _Tp, 4 > &v1, const Vec< _Tp, 4 > &v2)
static Vec< _Tp, cn > & | operator/= (Vec< _Tp, cn > &a, int alpha)
static Vec< _Tp, cn > & | operator/= (Vec< _Tp, cn > &a, float alpha)
static Vec< _Tp, cn > & | operator/= (Vec< _Tp, cn > &a, double alpha)
static Vec< _Tp, cn > | operator* (const Vec< _Tp, cn > &a, int alpha)
static Vec< _Tp, cn > | operator* (int alpha, const Vec< _Tp, cn > &a)
static Vec< _Tp, cn > | operator* (const Vec< _Tp, cn > &a, float alpha)
static Vec< _Tp, cn > | operator* (float alpha, const Vec< _Tp, cn > &a)
static Vec< _Tp, cn > | operator* (const Vec< _Tp, cn > &a, double alpha)
static Vec< _Tp, cn > | operator* (double alpha, const Vec< _Tp, cn > &a)
Vec< _Tp, 4 > | operator* (const Vec< _Tp, 4 > &v1, const Vec< _Tp, 4 > &v2)
static Vec< _Tp, cn > | operator/ (const Vec< _Tp, cn > &a, int alpha)
static Vec< _Tp, cn > | operator/ (const Vec< _Tp, cn > &a, float alpha)
static Vec< _Tp, cn > | operator/ (const Vec< _Tp, cn > &a, double alpha)
Related Functions inherited from cv::Matx< _Tp, cn, 1 >
static Matx< _Tp1, m, n > & | operator+= (Matx< _Tp1, m, n > &a, const Matx< _Tp2, m, n > &b)
static Matx< _Tp1, m, n > & | operator-= (Matx< _Tp1, m, n > &a, const Matx< _Tp2, m, n > &b)
static Matx< _Tp, m, n > | operator+ (const Matx< _Tp, m, n > &a, const Matx< _Tp, m, n > &b)
static Matx< _Tp, m, n > | operator- (const Matx< _Tp, m, n > &a, const Matx< _Tp, m, n > &b)
static Matx< _Tp, m, n > | operator- (const Matx< _Tp, m, n > &a)
static Matx< _Tp, m, n > & | operator*= (Matx< _Tp, m, n > &a, int alpha)
static Matx< _Tp, m, n > & | operator*= (Matx< _Tp, m, n > &a, float alpha)
static Matx< _Tp, m, n > & | operator*= (Matx< _Tp, m, n > &a, double alpha)
static Matx< _Tp, m, n > | operator* (const Matx< _Tp, m, n > &a, int alpha)
static Matx< _Tp, m, n > | operator* (const Matx< _Tp, m, n > &a, float alpha)
static Matx< _Tp, m, n > | operator* (const Matx< _Tp, m, n > &a, double alpha)
static Matx< _Tp, m, n > | operator* (int alpha, const Matx< _Tp, m, n > &a)
static Matx< _Tp, m, n > | operator* (float alpha, const Matx< _Tp, m, n > &a)
static Matx< _Tp, m, n > | operator* (double alpha, const Matx< _Tp, m, n > &a)
static Matx< _Tp, m, n > | operator* (const Matx< _Tp, m, l > &a, const Matx< _Tp, l, n > &b)
static Vec< _Tp, m > | operator* (const Matx< _Tp, m, n > &a, const Vec< _Tp, n > &b)
static bool | operator== (const Matx< _Tp, m, n > &a, const Matx< _Tp, m, n > &b)
static bool | operator!= (const Matx< _Tp, m, n > &a, const Matx< _Tp, m, n > &b)

## Detailed Description

### template<typename _Tp>
class cv::Scalar_< _Tp >

Template class for a 4-element vector derived from Vec.

Being derived from Vec<_Tp, 4> , Scalar_ and Scalar can be used just as typical 4-element vectors. In addition, they can be converted to/from CvScalar . The type Scalar is widely used in OpenCV to pass pixel values.

## Constructor & Destructor Documentation

## ◆ Scalar_() [1/4]

template<typename _Tp>

cv::Scalar_< _Tp >::Scalar_ | ( |  | ) |

default constructor

## ◆ Scalar_() [2/4]

template<typename _Tp>

cv::Scalar_< _Tp >::Scalar_ | ( | _Tp | v0,
|  | _Tp | v1,
|  | _Tp | v2 = `0`,
|  | _Tp | v3 = `0`
| ) |  |

## ◆ Scalar_() [3/4]

template<typename _Tp>

cv::Scalar_< _Tp >::Scalar_ | ( | _Tp | v0 | ) |

## ◆ Scalar_() [4/4]

template<typename _Tp>
template<typename _Tp2 , int cn>

cv::Scalar_< _Tp >::Scalar_ | ( | const Vec< _Tp2, cn > & | v | ) |

## Member Function Documentation

## ◆ all()

template<typename _Tp>

static Scalar_<_Tp> cv::Scalar_< _Tp >::all | ( | _Tp | v0 | ) |
| static

returns a scalar with all elements set to v0

## ◆ conj()

template<typename _Tp>

Scalar_<_Tp> cv::Scalar_< _Tp >::conj | ( |  | ) | const

returns (v0, -v1, -v2, -v3)

## ◆ isReal()

template<typename _Tp>

bool cv::Scalar_< _Tp >::isReal | ( |  | ) | const

returns true iff v1 == v2 == v3 == 0

## ◆ mul()

template<typename _Tp>

Scalar_<_Tp> cv::Scalar_< _Tp >::mul | ( | const Scalar_< _Tp > & | a,
|  | double | scale = `1`
| ) |  | const

per-element product

## ◆ operator Scalar_< T2 >()

template<typename _Tp>
template<typename T2 >

cv::Scalar_< _Tp >::operator Scalar_< T2 > | ( |  | ) | const

conversion to another data type

The documentation for this class was generated from the following file:

- core/include/opencv2/core/types.hpp